/*
 Пресвятий Антоне, допоможи ти мученику нашому, вірному тобі до кінця Боді.
 Ой да спаси його від прокляття сього єолімпівського контесто-початкового.
 Заряди сервери ті насущі на тести препотужні.
 Нехай кожне запитання що стане на його шляху,заходить і не лагає.
 Печеньки.
 */
//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
#define fast ios_base::sync_with_stdio(false);cout.tie(nullptr);cin.tie(nullptr);
#define endl '\n'
using namespace std;
#define N (int)(1e6+10) 
int mp1[N],mp[N];
int32_t main(){
    fast;
    int n;
    cin>>n;
    int a[n+1];
    for(int i=1;i<=n;i++){
        cin>>a[i];
    }
    int t1=0,t2=0;
    for(int i=1;i<=n/2;i++){
        if(a[i]==a[n-i+1]){
            mp1[a[i]]++;
            t1++;
        }
        else{
            mp[a[i]]++;
            mp[a[n-i+1]]++;
            t2++;
        }
    }
    int re=n;
    for(int i=1;i<=n;i++){
        int q=2*mp1[a[i]]+2*mp[a[i]];
        if(q>=(n+2)/2){
            re=min(re,t2);
        }
        else{
            int to=(n+2)/2-q;
            int t3=t2-mp[a[i]];
            t3*=2;
            to=to+to%2;
            if(t3+q>=(n+2)/2){
                re=min(re,mp[a[i]] + to+(t3-to)/2);
            }
            else{
                int res=mp[a[i]]+t3;
                q+=t3;
                to=(n+2)/2-q;
                to=to+to%2;
                re=min(re,res+to);
            }
        }
    }
    cout<<re<<endl;
}

